# -*- coding: utf-8 -*-
#!/usr/bin/env python

import sys
import datetime
from VoiceToText_docomo import VoiceToText_docomo
#from VoiceToText_Google import VoiceToText_Google
from Reply_DialogF import getReplyFromDialogF
from GetNews import GetNews
from GetWeather import GetWeather
from Translate_Google import Translate
from TextToSpeech_Jtalk import TextToSpeech_Jtalk
from TextToSpeech_eSpeak import TextToSpeech_eSpeak
from QA_docomo import QA_docomo
from GConversation_docomo import GConversation_docomo#インポートの追加



class BrainAction:
    #コンストラクタ(初期処理)
    def __init__(self):

        #処理ステータスの初期化
        self.flg_action='ini'
        
    #デストラクタ(終了処理)
    def __del__(self):
        print('end')

    #プロパティ
    #googleKey
    def google_key(self):
        return self.google_key
    
    def google_key(self,value):        
        self.google_key=value

    #docomoKey
    def docomo_key(self):
        return self.docomo_key
    
    def docomo_key(self,value):        
        self.docomo_key=value

    #Cliantaccesstoken
    def dialogF_token(self):
        return self.dialogF_token

    def dialogF_token(self,value):
        self.dialogF_token=value
        
    #flg/処理ステータス
    def flg_action(self):
        return self.flg_action
    
    def flg_action(self,value):
        self.flg_action=value    


    #失敗ケースの対応
    def act_err(self):
        #フラグ初期化
        self.flg_action='ini'
        #わからない発声
        TextToSpeech_Jtalk('わかりません。もう一度お願いします。'.encode('utf-8'),'resVoice.wav')
        
    #----------------------------------ここから
    #docomo APIで返答後にflgを初期化する
    def docomo_res(self):
        #フラグの初期化
        self.flg_action='ini'
    #----------------------------------ここまで

    #アクション
    #最初のアクションで処理分岐しステータスを返す        
    def Action_1st(self,voice1):
        
        #②文字データ化
        txtVoice=VoiceToText_docomo(voice1,self.docomo_key)
                
        #文字化したデータが空白となった場合、処理をスキップ
        if txtVoice=='' or  txtVoice ==u'。' or  txtVoice ==u'、' :
            self.act_err()
            return

        print(txtVoice)

        #返答をリクエスト
        txtReply=getReplyFromDialogF(txtVoice,self.dialogF_token)

        print(txtReply['result'][ 'score'])
        print(txtReply)
        #print(txtReply["result"]["action"])
        #マッチングスコアが低い場合は処理をスキップする。
        if txtReply['result']['score']<0.8:
            #修正-----------------------------------ここから
            #docomo雑談APIからの返答の取得
            DocomoText=GConversation_docomo(txtVoice,self.docomo_key)
            #発生
            TextToSpeech_Jtalk(DocomoText.encode('utf-8'),'resVoice.wav')
            #処理を抜ける
            self.docomo_res()
            #----------------------------------------ここまで

            return
        
        #DialogFlowにて制御されたactionを取得
        self.flg_action=txtReply["result"]["action"]
        print(self.flg_action)
        print(txtReply["result"]["action"])

        #DialogFlowにて返答フレーズ取得
        txtRes=txtReply["result"]["fulfillment"]["speech"]

        #取得フレーズが空白の場合は処理をスキップ
        if txtRes=='':
            self.act_err()
            return
        
        #DialogFlowにて返答フレーズの発声
        TextToSpeech_Jtalk(txtRes.encode('utf-8'),'resVoice.wav')
        print(txtRes)
        
        #⑤回答による分岐(DialogFlowからのActionにより制御)
        if self.flg_action=='news':
            #⑥ニュースの読み上げ
            news=GetNews()
                                    
            #⑩発声
            for rd in news['entries']:
                tmpTxt=rd['title']
                TextToSpeech_Jtalk(tmpTxt.encode('utf-8'),'resVoice.wav')
                print(tmpTxt)                

            #フラグ初期化
            self.flg_action='ini'    
            
        elif self.flg_action=='weather':
            #⑦天気予報
            #DialogFlowにて必要パラメータがそろっている場合に処理
            if txtReply["result"]["actionIncomplete"]==False:
                tmpArea=txtReply["result"]["parameters"]["area"]
                print(tmpArea)

                #⑩発声
                tmpWeather=GetWeather(tmpArea)
                for rd in tmpWeather['entries']:
                    TextToSpeech_Jtalk(rd['title'].encode('utf-8'),'resVoice.wav')
                    print(rd['title'].encode('utf-8'),'resVoice.wav')
                    
            #フラグ初期化
            self.flg_action='ini'


        elif self.flg_action=='translate':
            #⑧翻訳はフラグを保持して、続きのアクションへ
            print('translate')
            
       #Q&Aの処理-------------------------------------------------ここから
        elif self.flg_action=='question':
            #QAはフラグを保持して、続きのアクションへ
            print('question')
       #----------------------------------------------------------ここまで
            
        elif self.flg_action=='action_self':
            #⑪ロボットプロセスや動きに対しての制御
            tmpActSelf=txtReply["result"]["parameters"]["action_self"].encode('utf-8')
            print(tmpActSelf)
            
            if tmpActSelf=='終了':
                #終了時
                print('****END*****')
                sys.exit()
                
            elif tmpActSelf=='前進':
                #前進する
                print(tmpActSelf)
            elif tmpActSelf=='左':
                #左に曲がる
                print(tmpActSelf)
            elif tmpActSelf=='右':
                #右に曲がる
                print(tmpActSelf)
            elif tmpActSelf=='後退':
                #後退する
                print(tmpActSelf)
                
            self.flg_action='ini'           
            
        else:
            #その他の場合には処理をスキップ
             print('No Action. docomo')

                    
    #flg_action/ステータスによって処理を分岐 継続/2回目アクション
    def Action_2nd(self,voice1):
        
        #②文字データ化
        txtVoice=VoiceToText_docomo(voice1,self.docomo_key)
        
        #リクエストの内容が空白の場合、処理をスキップ
        if txtVoice=='':
            self.act_err()
            return
        
        #⑤回答による分岐
        if self.flg_action=='translate':
            #→⑧翻訳
            ph_e=Translate(txtVoice,self.google_key)#google_keyにはサービスキー     
            print(ph_e)

            #⑩発声
            TextToSpeech_eSpeak(ph_e,2,'english')#--ph_eの後ろに[result]をつけます。

            #flg_actionのクリア
            self.flg_action='ini'

           #Q&Aの処理------------------------------------------------ここから
        elif self.flg_action=='question':

            #質問の返答リクエスト
            TextQ=QA_docomo(txtVoice,self.docomo_key)

            #回答を発声する
            TextToSpeech_Jtalk(TextQ.encode('utf-8'),'resVoice.wav')

            #フラグ初期化
        self.flg_action='ini'
        #-------------------------------------------------------------ここまで


            
            
